#!/usr/local/bin/perl
#
# aexpl.pl - a exploit crawler to find bad stuff on your server.
# Copyright (C) 2004 by Enrico Kern, H Zero Seven (www.h07.org) 
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

use Config::Simple;
use File::Locate;
use Digest::MD5;      
use Fcntl;

# vars
$iArgCount = $#ARGV + 1;
$cfg;											# config object
$locatedb;										# locate database
$exploitdb;										# exploit database
$sendlog;										# send log
$mailbin;										# sendmail
$mailadd;										# adminmail
$notifyuser;									# user notify
$usermessage;									# user msg
$logfile;										# logfile
$alertlog;										# alert log
$runscript;										# script support
$userscript;									# script to run

# need config file as param
if($iArgCount == 0 || $iArgCount > 1)
{
	print("usage: aexpl.pl configfile\n");
}
else
{
	printheader();
	
	if( init() ) 
	{
		startscan();
	}
	else
	{
		print("configuration error!\n");
	}
}


# read configuration values 
sub init()
{
	# configuration
	print("--> Process Configuration in progress..\n");
	$cfg = new Config::Simple("$ARGV[0]");
    $locatedb  	= $cfg->param("locatedb");   
	$exploitdb 	= $cfg->param("exploitdb");	 	
	$alertlog  	= $cfg->param("alertlog");
	$logfile   	= $cfg->param("logfile");
	$mailbin	= $cfg->param("mailbin");
	$sendlog	= $cfg->param("sendlog");
	$mailadd	= $cfg->param("mailadd");
	$notifyuser	= $cfg->param("notifyuser");
	$usermessage= $cfg->param("message");
	$runscript	= $cfg->param("runscript");
	$userscript = $cfg->param("userscript");

	return(true);
}

# print programm header
sub printheader()
{
	print("[ AntiExploit 1.2 - locate bad files on your server ]\n");
	print("[          www.h07.org/projects/aexpl/              ]\n\n");
}

# start scan
sub startscan()
{
	# load exploit.db in a array
	open(EXPDATA, $exploitdb) || die;
	my @expdb = <EXPDATA>;	
	$expl  = @expdb;
	close EXPDATA;
	
	print("--> $expl Exploits/Tools found in Database\n");	

	print("--> Scan in progres..\n\n");

	# search for file on local harddisk
	$alerts = 0;
	$useralerts = 0;
	$founduser;
	
	foreach $file(@expdb)
	{
		# sum vars
		@foundexpl;
		$foundexpll = @foundexpl;

		# store filename and md5sum
		$file =~ /(.*?):(.*)/;		
		$filename 	= $2;
		$md5sum		= $1;
		
		my @locatelist = locate "$filename", "$locatedb";
		my $locatell	= @locatelist;
		foreach $ffile(@locatelist)
		{
			# check if file exist! 
        	if(! -d $ffile && -e $ffile)
			{
					# file exists in locatedb, check harddisk
					if(sysopen(FH, $ffile, O_RDONLY) )
					{           
						#md5 check
						binmode(FH);
						$fmd5 = Digest::MD5->new->addfile(*FH)->hexdigest || print(".e.\n");
						close(FH);
					}
			}

			if($md5sum eq $fmd5)
			{
				# file match! report as exploit	
				print("--> Exploit alert: $ffile\n");
				$alerts += 1;
				
				# get file informations
				my ($dev, $ino, $mode, $nlink, $uid, $gid, $rdev, $size, $atime, $mtime, $ctime, $blksize, $blocks) = stat($ffile);
				my ($owner) = getpwuid($uid);

				# add to array
				$foundexpl[$foundexpll] =   "--> $ffile\n--> owner -> $owner size -> $size\n\n";
				$foundexpll += 1;

				# print add. informations
				print("--> Fileinfo     : owner -> $owner size -> $size\n\n");
				# userstats
				if( !defined($founduser{$owner}) )
				{
					$founduser{$owner} = @owner;
					$useralerts += 1;
				}
			}
		} #foreach locate	
	} # foreach file

	print("--> Scan finished..\n");
	
	# mailstuff etc.
	if($sendlog eq "yes")
	{
		sendmail();
	}
		
	# show results
	print("-------------------------------------------\n");
	print("Exploit alerts: $alerts\n");
	print("Suspect users : $useralerts\n\n");

	# print list of suspect users and run userscript
	print("list of users with suspect files:\n");
	foreach $key ( keys %founduser )
	{
		print("$key\n");
		
		if($runscript eq "yes")
		{
			system("$userscript $key");
		}
	}
	print("\n");

}

# send mail
sub sendmail()
{
	my $hostname = `hostname`;
	my $date	 = `date`;
	unless(open (MAIL, "|$mailbin $mailadd")) 
	{
		print "error.\n";
		warn "Error starting sendmail: $!";
	}
	else
	{
		print MAIL "From: root\n";
		print MAIL "To: $mailadd\n";
		print MAIL "Subject: $hostname AntiExploit report\n\n";
		print MAIL "AntiExploit looked for $expl Exploits/Tools and ";
		print MAIL "found $alerts matching files\n\n";
		print MAIL "report generated at: $date\n";
		print MAIL "matched files: \n\n";
	
		foreach $fexpf(@foundexpl)
		{
			print MAIL "$fexpf\n";
		}

		print MAIL "\n\n";
		print MAIL "http://www.h07.org/projects/aexpl/";
		close(MAIL) || warn "Error closing mail: $!";
		print "--> Report mail was sent to $mailadd\n";
	}

}

