#!/usr/local/bin/perl
#
# aexpl-grst.pl - a grsec exec log analyzer to find bad stuff on 
# your server.
#
# Copyright (C) 2004 by Enrico Kern, H Zero Seven (www.h07.org) 
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.


###############################################################
#                          BEWARE!                            #
#                                                             #
#     If you are a perl-freak this source is the worst        #
#     perl-script you ever seen, cause i needed a quickhack   #
#     and not a perfect perlscript ;)                         #
###############################################################


use Config::Simple;
use File::Tail;

$iArgCount = $#ARGV + 1;
$cfg;                                           # config object
$exploitdb;                                     # exploit database
$mailbin;                                       # sendmail
$mailadd;                                       # adminmail
$log;											# logfile

if($iArgCount == 0 || $iArgCount > 1)
{
	printheader();
	print("--> usage: aexpl-grst.pl configfile\n");
}
else
{
	init();
	analyze();
}

# print programm header
sub printheader()
{
    print("[ AntiExploit 1.2 - locate bad files on your server ]\n");
	print("[      aexpl-tools: grsec-log analyzer 0.1          ]\n");
    print("[           www.h07.org/projects/aexpl/             ]\n\n");
}

# init
sub init()
{
	# read config values
	$cfg = new Config::Simple("$ARGV[0]");
	$exploitdb  = $cfg->param("exploitdb");
	$mailbin    = $cfg->param("mailbin");
	$mailadd    = $cfg->param("mailadd");
	$log		= $cfg->param("log");

	# load exploit db in array
	open(EXPDATA, $exploitdb) || die;
	@expdb = <EXPDATA>;
	$expl  = @expdb;
	close EXPDATA;

	# load exploit informations in a hash for
	# faster access
	
	$exploitkey;

	foreach $expfile(@expdb)
	{
		$expfile =~ /(.*?):(.*)/;
		$md5sum = $1;				# md5sum, not needed yet!
		$filename = "\ $2\ ";
		$exploitkey{$filename} = "$md5sum";
	}
}

# analyze logfile
sub analyze()
{
	$file=File::Tail->new($log);
	while (defined($line=$file->read)) {
    	 # check if line contains a exploit-filename
		 foreach $key ( keys %exploitkey )
		 {
			$line =~ /\ exec\ of\ (.*)\ by\ /; 
			if (index($line, $key) != -1)
			{
				print("$line\n");
				sendmail();
			}
		 }
	}
}

sub sendmail()
{
    my $hostname = `hostname`;
	my $date     = `date`; 
	unless(open (MAIL, "|$mailbin $mailadd")) 
	{
		print "error.\n";
	    warn "Error starting sendmail: $!";
	}
	else    
	{
		print MAIL "From: root\n";
	    print MAIL "To: $mailadd\n";
	    print MAIL "Subject: $hostname AntiExploit LogAnalyzer Warning\n\n";
	    print MAIL "The AntiExploit grsecurity Log-Analyzer is watching the file $log and ";
	    print MAIL "a alert occured!\n\n";
	    print MAIL "report generated at: $date\n";
    	print MAIL "matched suspect filename: $key\n\n";
		print MAIL "Log-File tail:\n\n";
		print MAIL "$line";
		print MAIL "\n\n";
	    print MAIL "http://www.h07.org/projects/aexpl/";
	    close(MAIL) || warn "Error closing mail: $!";
	}
}
